unit Delpsamu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, GSOBShel, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    LoadRec: boolean;
    procedure DoReplace;
    procedure LoadRecord;
    function IsFieldChanged: boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DoReplace;
begin
   if Edit1.Tag > 0 then GSOBShel.StringPut('LASTNAME',Edit1.Text);
   if Edit2.Tag > 0 then GSOBShel.StringPut('FIRSTNAME',Edit2.Text);
   GSOBShel.Replace;
end;

procedure TForm1.LoadRecord;
begin
   LoadRec := true;
   Edit1.Text := GSOBShel.StringGet('LASTNAME');
   Edit2.Text := GSOBShel.StringGet('FIRSTNAME');
   Edit1.Tag := 0;
   Edit2.Tag := 0;
   LoadRec := False;
   IsFieldChanged;
end;

function TForm1.IsFieldChanged: boolean;
var
   tf: boolean;
begin
   tf := false;
   tf := tf or (Edit1.Tag > 0);
   tf := tf or (Edit2.Tag > 0);
   if tf then
      Label3.Caption := 'Record Has Been Modified'
   else
      Label3.Caption := 'Record Not Modified';
   Result := tf;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   GSOBShel.Select(1);
   GSOBShel.Use(Edit3.Text);
   GSOBShel.GoTop;
   LoadRecord;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   GSOBShel.CloseDataBases;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   if IsFieldChanged then DoReplace;
   GSOBShel.Skip(1);
   LoadRecord;
   Button1.Enabled := not GSOBShel.dEOF;
   Button2.Enabled := not GSOBShel.dBOF;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   if IsFieldChanged then DoReplace;
   GSOBShel.Skip(-1);
   LoadRecord;
   Button1.Enabled := not GSOBShel.dEOF;
   Button2.Enabled := not GSOBShel.dBOF;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
   Edit1.Tag := 1;
   IsFieldChanged;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
   Edit2.Tag := 1;
   IsFieldChanged;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
   if not FileExists(Edit3.Text) then exit;
   Select(1);
   Use(Edit3.Text);
end;

end.
