program GSDMO_16;
{------------------------------------------------------------------------------
                    DBase File and Memo Editor (External)

       Copyright (c)  Richard F. Griffin

       20 January 1993

       102 Molded Stone Pl
       Warner Robins, GA  31088

       -------------------------------------------------------------
       This program reads a dBase file 'GSDMO_07.DBF with memo file
       'GSDMO_07.DBT'.   It uses MS-DOS's EDIT.COM to work with the
       memo fields. Assign the correct file path in the Exec command
       for EDIT.COM.

            --- WILL NOT COMPILE AS A WINDOWS APPLICATION ---
            (Similar technique may be used to WINEXEC Notepad)
------------------------------------------------------------------------------}

{$M 8192,0,65536}      {Needed to allow room for the 'Exec'ed editor}

uses
   CRT,
   Dos,
   GSOB_Dsk,
   GSOBShel;
const
   TxFileName = 'GSDMO_07.MMO';
var
   TxFile  : Text;
   t1      : longint;
   t2      : longint;
   c       : char;
   domore  : boolean;
   FilStr  : string;
                     {Procedure to display the memo field}

procedure MemoToDiskFile(fldname: string);
var
   i,
   ml   : integer;

begin
   Rewrite(TxFile);
   GetFTime(TxFile, t1);
   MemoGet('COMMENTS');
   ml := MemoLines;
   if ml <> 0 then
      for i := 1 to ml do
         Writeln(TxFile,MemoGetLine(i))
   else
   Writeln(TxFile,' ');               {at least one byte in the file}
   Close(TxFile);
end;

procedure DiskFileToMemo(fldname: string);
var
   i   : integer;
   s   : string;
   m1,
   m2  : string[10];
begin
   m1 := FieldGet('COMMENTS');
   MemoClear;
   Reset(TxFile);
   GetFTime(TxFile, t2);
   if t1 <> t2 then    {See if file changed}
   begin
      while not EOF(TxFile) do
      begin
         Readln(TxFile,s);
         MemoInsLine(-1,s);
      end;
      MemoPut('COMMENTS');
      m2 := FieldGet('COMMENTS');
            {If the memo field number has changed, save the DBF record}
      if m1 <> m2 then Replace;
   end;
   Close(TxFile);
end;

                               {Main program}
begin
   ClrScr;
   domore := true;

   if not FileExist('GSDMO_07.DBF') then
   begin
      writeln('File GSDMO_07.DBF not found.  Run GSDMO_07 to create.');
      halt;
   end;
                       {The 'Real' example starts here}

   Assign(TxFile,TxFileName);
   Rewrite(TxFile);

   Use('GSDMO_07');
   MemoWidth(75);        {sets width of the memo line.  Default is 255}
   GoTop;
   while not dEOF and domore do
   begin
      ClrScr;
      writeln(FieldGet('LASTNAME'),', ',
              FieldGet('FIRSTNAME'));
      MemoToDiskFile('COMMENTS');
      SwapVectors;
      Exec('C:\DOS\EDIT.COM',TxFileName);
      SwapVectors;
      if FileExist(TxFileName) then
         DiskFileToMemo('COMMENTS')
      else
         domore := false;
      Skip(1);
   end;
   CloseDataBases;
end.

